Getting Started with dwgExplore for AutoCAD

Welcome to the Help system for dwgExplore for AutoCAD. dwgExplore is AutoCAD add-on ObjectARX application which allows user to find and replace identical or similar groups of objects (patterns) in drawing.

It can be compared with Find and Replace option in Word or any other text editor. But instead of text, dwgExplore does Find and Replace geometrical 2D AutoCAD objects.

Please select from the following options for more information on dwgExplore for AutoCAD:

  • About CAD Project Point
  • Supported AutoCAD and Windows versions
  • Installing dwgExplore
  • dwgExplore Terminology and Definitions
  • Using dwgExplore User Interface

© 2015 CAD Project Point, Inc


About CAD Project Point

CAD Project Point, Inc. designs and sells products to enhance the performance of AutoCAD drafting software.

Contact Information:

Web site | http://www.cpp.co.rs/
Email | support@cpp.co.rs
Address | We are located in Belgrade, Serbia.


Supported AutoCAD and Windows versions

Supported AutoCAD versions:

AutoCAD 2007

AutoCAD 2008
AutoCAD 2009
AutoCAD 2010
AutoCAD 2011
AutoCAD 2012
AutoCAD 2013
AutoCAD 2014

AutoCAD 2015
AutoCAD 2016

Supported Windows version (32 bit and 64 bit) :

Windows XP

Windows 7

Windows 8

Windows 8.1


Installing dwgExplore

During installation, dwgExplore will modify registry and add(copy) itself to the AutoCAD’s folder (folder where acad.exe is, usually c:\Program Files\Autodesk\AutoCAD 20XX). Therefore, user should start installation using ‘Run As Administrator’ option.

Tip : To find ‘Run As Administrator’ option, right click on the install package and find it in the context menu.

Once installation is started, a dialog as on image below will show

dwgExplore installation dialog

Licence Agreement conditions have to be accepted by checking I accept the agreement button.

Licence Agreement dialog

Next step is to select installation directory for dwgExplore

Installation directory selection dialog

Then, dwgExplore will detect all installed instances of AutoCAD on your machine and display them. Select those AutoCAD versions for which dwgExplore should be installed for(one license is enough for any number of AutoCAD installations on a single machine). Dialog is shown in figure below.

AutoCAD versions to install dwgExplore dialog

dwgExplore will be installed for all selected versions of AutoCAD


File and Folders created

After installation, dwgExplore folder is as in figure below.

dwgExplore installation folder

Bin directory contains folders for each and every AutoCAD version dwgExplore is installed for. AutoCAD<version> directory contains 32 bit and 64 bits cppdwgexplore.arx applications of all installed dwgExplore versions.

Location of cppdwgexplore.arx file

Config directory contains only dwgexplore.ini file. It is used to define configuration variables. Those are not to be changed by user.

Licence directory contains dwgExplore licence file, dwgwxplore.lic. dwgExplore has to write to this file during first AutoCAD session after dwgExplore installation, as well as during product activation.


Product activation

Upon expiration of free trial, product has to be activated.

To activate it :

Go to Cpp’s Tools menu and open About dialog. It is shown in figure below.

About dwgExplore dialog

Activation code is required to activate product. Follow purchase licence here link to purchase activation code.

Click Activate product button to open Register Application (image below). Enter activation code in Register Application dialog and click Ok.

Register Application dialog


Terminology and Definitions

Throughout dwgExplore application and documentation, number of expressions and definitions is often used. In order to understand dwgExplore functionality one needs to fully understand meaning of those expression.

It is explained in details in this section.


Pattern definition

In dwgExplore, pattern is group of 2D elements in a drawing (can be only one element). Elements (entities) that can be included in pattern are: lines, polylines, circles, arcs, rectangles, polygons, splines, text, mtext, blocks, arrays and dimensions. One pattern consisting of 14 entities (6 lines, 5 arcs and 3 polylines) is shown bellow

Pattern example

Pattern types used in dwgExplore

Target pattern is group of elements selected by user, to be searched for.

Matched pattern is group of elements in active drawing found by dwgExplore that is matched to target pattern, according to search criteria.

Replacement pattern is group of elements defined by user to be used to replace some or all matched patterns in active drawing.


Search types

Exact Match definition

Exact Match searches for patterns in active drawing that are identical to target pattern. Matched patterns can be rotated or scaled or both in respect to target pattern.

Full Exact Match is search where all elements from target pattern are to be found in matched pattern.

Full exact match examples

Partial Exact Match is search where only some elements from target pattern are to be found in matched pattern. Target pattern (bold) in figure below consists of 19 entities. Its partial exact matching patterns are composed of 14 entities.

Partial exact match examples

Close Match definition

Close Match searches for patterns that are similar to target pattern. Matched pattern can be rotated or scaled or both in respect to target pattern.

Full Close Match is search where all elements from target pattern are to be found in matched pattern.

Full close match examples

Partial Close Match is search where only some elements from target pattern are to be found in matched pattern.

Partial close match examples


Search limitations

Limitations

  • Element types in target pattern and in matched patterns must match to each other on one to one basis. In figure below, two visually identical patterns are shown. Right pattern consists of one poly line while left pattern consists of six lines and one arc. In dwgExplore, these patterns are different.

Visually identical patterns but composed of different elements

  • Group of objects, generated by mirror command will not be matched by dwgExplore (image below)

Mirrored patterns

  • dwgExplore can't search for 3D objects/patterns in drawing . It can only search in a XY plane (i. e. Z=0 plane) for 2D objects. But, replacement pattern may have 2D and/or 3D objects. All the 3D objects in the drawing will be ignored/skipped in search operation.


Using dwgExplore for AutoCAD

dwgExplore commands are available :

o From Cpp Tools menu

o From Cpp Tools ribbon

o From Cpp's Tools options in context menu

as shown in images bellow:

Cpp Tools menu

Cpp Tools ribbon

Cpp Tools context menu options

dwgExplore commands are :

Find Exact Match is used to search active drawing for groups of objects (matched patterns) which are identical (full or partial) to target pattern. Matched patterns are displayed in Results dialog and can be replaced with replacement pattern defined by user.

Find Close Match is used to search active drawing for groups of objects (matched patterns) which are similar (full or partial) to target pattern. Matched patterns are displayed in Results dialog and can be replaced with replacement pattern defined by user.

Quick Replace is used to search active drawing for groups of objects (matched patterns) which are identical (full or partial) to target pattern and to instantly replace matched patterns with replacement pattern defined by user.

User should select objects in drawing to be used as target pattern definition before using any of dwgExplore’s commands. Example of target pattern objects selection is shown in figure below.

Selected objects from which target pattern consists

Choice of any available dwgExplore’s commands (Find Exact Match, Find Close Match or Quick Replace) opens Find dialog. In this dialog user can set search criteria and parameters.


dwgExplore’s Find dialog

Find dialog(or its derivative, Quick Replace) is opened upon selection of any dwgExplore’s command . Available commands are :

o   Find Exact Match

o   Find Close Match

o   Quick Replace.

Find dialog is shown in figure below.

Find... dialog

It consists of :

o   Find what section(Target pattern definition)

o   Find in group,

o   Geometry card

o   Location card

o   Match Options card

All the search (explore) parameters are to be set in Find dialog.


Search parameters : Target pattern (Find what group)

Target pattern (Find what group) is shown in figure bellow :

Find what group

Pick...

Pick elements selected by user in currently active drawing and use them as target pattern.

Info...

Open Pattern info dialog (described below) with target pattern details

Top...

Top view of target pattern

3D...

Isometric view of target pattern

Target Properties

Target pattern properties are :

o File | Name of file where target pattern is
o Layout | Name of target pattern’s host layout in above file
o Count | Number of target pattern entities
o Extents | Target pattern extents

Pattern Info dialog

Pattern Info dialog

File | Name of file where target pattern is
Layout | Name of target pattern’s host layout in above file
Pattern Image | Target pattern preview, in Top view (Top) or in Isometric view (3D)
Pattern Properties | Geometry properties of target pattern
Pattern Entities | List of the all the target pattern entities with their basic properties: Entity type (Type), Layer where entity is located (Layer), entity handle in drawing (Handle)


Search parameters: Geometry

Geometry card is shown in picture below

Geometry card

Available options (parameters) on Geometry tab are:

Rotational invariant dwgExplore will look for matched patterns that are rotated in respect to target pattern

Rotational invariant

Scale Invariant dwgExplore will look for matched patterns that are scaled in respect to target pattern

Scale invariant

Scale and Rotational invariant booth checked

Full Match | When it is checked, all the target pattern element are to be found in matched pattern
Partial Match | When it is checked, only some of target pattern elements are to be found in matched pattern.
Minimal entities in matching patterns | Used only in Partial Match. Minimal number of entities in matched pattern required for it to be included in matching results. Minimal number is 3 and maximal number is total number of elements in target pattern. When Minimal entities in matching pattern parameter decreases, search time increases.
Scale Range | Used only when Scale Invariant option is selected. Defines acceptable (required) scale range of matched patterns. Default value for scale range is any scale. Custom Scale Range is defined through Scale Range dialog displayed on figure below

Scale range dialog

In Scale range dialog , Specify allowed scale range (in respect to target pattern) option should be used to specify custom scale range of matched patterns, from minimal to maximal size (in respect to target pattern size).


Search parameters: Location

Location card is shown in picture below

Location card

Available options on Location tab are :

Look in Model Space | Active drawing Model Space will be searched for target pattern
Look in Paper Space | Active drawing Paper Space Layouts will be searched for target pattern
Look in Blocks | Block definitions of active drawing will be searched for target pattern
Ignore Off Layers entities | Entities which are on off Layers in active drawing will not be included in search
Ignore Frozen Layers entities | Entities which are on frozen Layers in active drawing will not be included in search


Search parameters: Match Options(in Find Exact Match)

Match Option card for Find Exact Match command is shown below

Match Options card for Exact Match command

Available Match Options are

Match Layer | Layer property of target pattern elements must match Layer property of matched pattern elements
Match Colour | Colour property of target pattern elements must match colour property of matched pattern elements
Match Line Type | Line type property of target pattern elements must match line type of matched pattern elements
Match Line Weight | Line weight property of target pattern elements must match line weight of matched pattern elements
Include Target in Results | Target pattern itself will be included in a list of results(if target pattern’s file and layout are included in search)

Remark: With more options selected, search time will decrease.

© 2015 Altiva Software, Inc


Search parameters: Match Options(in Find Close Match)

Match Options card in Find Close Match is displayed in figure below

Match Options card for Find Close Match command

In addition to Match Options of Find Exact Match dialog (described in previous page), in Find Close Match dialog there is only one more additional settings(option) :

It is Precision list box, used to specify how similarity level of target and matched pattern is evaluated. This selection sets number of internally used parameters, used by dwgExplore search algorithms.

Available Precision levels are

For very similar patterns (fast, recommended) | Should be used for patterns that are copy & pasted, and slightly modified after paste. Search time is the least of all three options.
For similar patterns | Should be used for patterns that are copy & pasted, and significantly modified after paste.
For only partly similar patterns (slow) | Should be used for patterns that are not copy & pasted, but generated externally (for example, scanned drawing converted to vector form).


Find Exact (Close) Match results dialog

Results of dwgExplore search are displayed in Find Exact(Close) Match results dialog (image below)

Find exact results dialog

Find exact (close match) results dialog contains next options:

Files | Name of that drawing that contains matched patterns displayed in Match Patterns tab of dialog
dwgExplore additional options button |
Reposition | Restores results dialog and active drawing window to "remembered, previously saved" positions. Whenever user closes results dialog, dwgExplore saves its position and position of active drawing window
Target & Replacement card | Used to inspect target pattern and to inspect and create replacement pattern
Matched Patterns card | Used to display list of matched patterns. Also, it contains buttons to define zoom factor to selected pattern as well as to replace or delete selected pattern(s).


Matched Patterns card

Match Patterns card is shown in picture below

Matched Patterns card

Match Patterns card contains following controls and buttons:

  • List of matched patterns found by dwgExplore search, according to search criteria, with columns
No | Serial number of matched pattern in list
Layout/Block | Matched pattern host Layout name or host Block name
Count | Number of objects (AutoCAD entities) in matched pattern. This column is in list only if results of partial match search (exact or close) are displayed. Otherwise, (if results of full match search are displayed) number of entities in matched pattern is equal to number of entities in target pattern.
Distance | It describes level of similarity between target pattern and matched pattern. It is in range of [0.0 - 1.0] with 0.0 being distance of identical patterns and 1.0 being distance of significantly different patterns. Column is present only if results of close match search are displayed in list.
Scale | Matched pattern scale in respect to target pattern
Azimuth | Matched pattern rotation angle in respect to target pattern(CCW)

o Search button [image] , is used to perform additional filtering of matched patterns result set. Find dialog (opened via Search button) is shown in figure below.

Search/filter matched patterns result set dialog

One can filter matched patterns result in respect to:

Layout/Block name | Text. Always enabled. Filter those matched patterns whose Layout/Block name contains specified text. To skip this filter condition leave empty field.
Entity count | Integer range [min, max]. Enabled when results of partial match search are displayed. To skip this filter condition, leave both Entity Count fields (min and max) empty.
Scale | Real number range [min, max]. Enabled when results of Scale Invariant search are displayed. To skip this filter condition, leave both Scale fields (min and max) empty.
Classification distance | Real number range [min, max]. Enabled when results of Close Match search are displayed. To skip this filter condition, leave both Classification distance fields (min and max) empty.

o Show All matched patterns in result set again(meaningful if result set had been filtered using option described above)

o Sync, it checks and synchronize state of match patterns in list with its actual state in drawing. For example, consider this scenario. User replace one of patterns in list(using Replacement button). Status of matched pattern in list is changed to “replaced” (shown with icon next to pattern). Then user focuses to drawing and use AutoCAD’s Undo operation until dwgExplore replacement is undone. Status of matched pattern in results dialog is not updated automatically (still showing “replaced”). Clicking on Sync button user starts dwgExpore synchronization process, that will detect that matched pattern is in its original state (not replaced) again, and update its status in list accordingly.

o Collapse/Expand All, Collapse/Expand All matched patterns in the list,

o Select All - Select all the matched patterns in the list,

o Zoom – It sets zoom factor of selected match pattern in the list. Extents link is zooming active drawing by its extents, Auto zoom sets zoom on/off, Flash sets selected matched pattern flashing on/off,

o Replace – It replaces all the selected matched patterns in list with replacement pattern

o Delete – It deletes all the selected matched patterns in list


Target & Replacement card

This card is used to define replacement pattern, i.e. pattern to be used to replace matched patterns in their host drawing. Target & Replacement card is shown in figure below.

Target & Replacement card

Find pattern | It zooms target pattern in its host drawing.
Replacement | It opens Replacement Pattern Editor to create/modify replacement pattern. Then, that pattern is used to replace matched patterns in their host drawing.
Replacement and Target Patterns | It is preview of replacement pattern over target pattern


Replacement pattern definition

To define replacement pattern, user should select Replacement option in Target & Replacement card of Results dialog, or Edit... option in Quick Replace dialog. Then, new drawing in AutoCAD, named as "ReplacementPattern*.dwg", is opened. An example of Replacement Pattern Editor is shown in figure below.

Replacement Pattern Editor drawing

As it is shown, target pattern is inserted in new drawing in gray colour. It is referenced as Shadow Target Pattern. Its only purpose is to help properly position replacement pattern in respect to target. On the right side, there is short description of drawing purpose. It is important to mention that all the automatically created objects (shadow target pattern and help text), will not be included in resulting replacement pattern.

Replacement Pattern Editor Options are available in Cpp’s Tools context menu. Cpp’s context menu in Replacement Pattern Editor is different than Cpp’s context menu in other drawings. This type of menu is displayed only here, in this automatically created drawing, and cannot be used and/or accessed in other drawings. It is shown on figure bellow

Cpp's Tools context menu in Replacement Pattern Editor drawing

dwgExplore’s Replacement Pattern Editor context menu options are

Pick Replacement | All the objects in drawing(not including automatically generated) will be used as replacement pattern
Show Shadow Target | Shadow target pattern is shown in gray colour in drawing (it is displayed by default)
Hide Shadow Target | Shadow target pattern is hidden
Insert Target | Copy of target pattern entities is inserted in Replacement Pattern Editor drawing
Remove Target | Target pattern entities, previously created/inserted with Insert Target option, are deleted
Clear Editor | All the non automatically generated objects (user draw them or insert them by Insert Target option) are deleted from drawing

Example of creating replacement pattern

In Replacement Pattern Editor, as on the image on top of page

o   Use Insert Target option to insert copy of target pattern in Replacement Pattern Editor drawing.

o   Modify inserted target pattern (replace 3 corners with arcs, replace 1 one arc with corner, add circle in middle of chair symbol, ...)

o   Use Hide Shadow Target option to hide shadow target pattern

Result is displayed on figure below

First Target pattern is inserted and then modified in replacement drawing

When replacement pattern editing is finished, user should use Pick Replacement option. There is no need to select elements in Replacement Pattern Editor drawing prior to Pick Replacement. All the non automatically generated objects in drawing are used by dwgExplore to create replacement pattern. Then, replacement pattern is displayed in Target&Replacement card of Results dialog(or next to target pattern in Quick Replace dialog).

Replacement and Target pattern shown in dialog


Quick Replace command

Quick Replace is used to search active drawing (by exact match criteria) for groups of objects (matched patterns) that are identical (full or partial) to target pattern, and to instantly replace matched patterns with replacement pattern defined by user. Find dialog for Quick Replace command is shown in figure below.

Find dialog for Quick Replace command

In dialog, user can click on :

Edit... | to define/edit Replacement pattern
Info... | to review detailed information about Replacement pattern
Options... | to set replacement parameters by Replace/Change Options dialog
Top ... , 3D... | to choose display mode of replacement pattern

Search options in Geometry, Location and Match Options cards are the same as in Find Exact Match command.

When Target and Replacement patterns are defined, search and replace procedure can be started by Run button. Quick Replace procedure will automatically replace all the matching patterns in active drawing with replacement pattern. When Quick Replace is done, information about replaced patterns is displayed

Quick Replace information dialog

User can inspect replaced patterns in Quick Replace results dialog (shown in figure below).

Quick replace results dialog

Quick replace results dialog displays list of all the replaced patterns in active drawing. User can focus to each and every replaced pattern.

There are no Replace and Delete buttons.


dwgExplore additional options button

dwgExplore’s additional options are available through button [image] displayed in Find exact results or Find close results dialog

Additional options button [image] ,with its menu is shown in figure below.

dwgExplore additional options menu

Additional options are :

Replace/Change

Replace/Change Options

activate Replace/Change options dialog described bellow

View Target Pattern

zoom target pattern in its host drawing

View Replacement Pattern

zoom replacement pattern in its host drawing

Inspect selected pattern

display details about selected pattern

Pattern properties window

open modeless topmost dialog displaying basic pattern properties(position, size, ...). Its content is automatically updated when user change selection in matched patterns list.

Isolation

Isolate selected patterns

only selected matched patterns in list will remain visible in drawing. All the other elements will be hidden. dwgExplore uses AutoCAD’s Isolate Objects function to accomplish this task.

Tip : Please, note that in some configurations AutoCAD Isolate Objects can be slow causing dwgExplore’s Isolate selected patterns to be slow also

End patterns isolation

hidden elements by Isolate selected patterns function will become visible again. dwgExplore uses AutoCAD’s End Object Isolation function to accomplish this task.

Copy selection in new drawing

copy selected matched patterns in new drawing

Explorer setting

display configuration settings of dwgExplore

Replace/Change Options dialog is shown in figure below

Replace/Change Options dialog

General Change Options are used to define the way of pattern replacement

Replace mode | Matched patterns will be replaced with replacement pattern(i.e. matched pattern deleted and replacement pattern inserted)
Modify (add only) mode | Matched patterns will be kept in active drawing and replacement pattern will be drawn (inserted) over it. In figure below, these options are presented

Matched pattern (left), Replace Mode (middle) and Modify (add only) mode (right)

Draw order

Try to keep draw order | dwgExplore tries to evaluate draw order of matched pattern and maintains the same draw order for inserted replacement pattern also(meaning that all AutoCAD elements bellow matched pattern should remain below inserted replacement pattern, and all the elements above matched pattern should remain above inserted replacement pattern also, once replacement procedure is done). Tip : choosing to keep draw order can significantly slow down replacement procedure in large drawing
Put replacement on top | Do not try to keep draw order(this is default option).

Change type (only for partial search).

Full replacement | During replacement, insert all the elements/entities of replacement pattern no matter what its intersection with selected partial matching pattern is
Partial replacement | Insert only those replacement pattern entities that intersect with selected partial matching pattern (it is shown on figure below)

Replacement pattern drawn over target pattern (left), matched pattern in active drawing (middle) and partial replacement done in active drawing (right)

As it is shown in figure, those replacement pattern entities (black) that intersect at least one of matched pattern entities, and only them, are inserted in drawing to replace matched pattern.


Getting Started with dwgExplore for AutoCAD

Welcome to the Help system for dwgExplore for AutoCAD. dwgExplore is AutoCAD add-on ObjectARX application which allows user to find and replace identical or similar groups of objects (patterns) in drawing.

It can be compared with Find and Replace option in Word or any other text editor. But instead of text, dwgExplore does Find and Replace geometrical 2D AutoCAD objects.

Please select from the following options for more information on dwgExplore for AutoCAD:

  • About CAD Project Point
  • Supported AutoCAD and Windows versions
  • Installing dwgExplore
  • Terminology and Definitions
  • Using dwgExplore